unit RegresPoly;                                      {15.04.2016}

{Ce  programme repose sur l'analyse dcrite dans "Mthode mathmatiques pour
calculateurs arithmtiques (Dunod 1965) - chapitre 27 Rgression multiple"
adapt  la rgression polynomiale.
Les rem numrots font rfrence  ce document.
L'auteur dcrit une mthode par pas qui ajoute une variable si elle apporte
la plus grande amlioration de la prcision de l'ajustement ou la supprime.
Ce sont les valeurs F1 et F2 qui autorisent l'introduction ou le retrait d'une
variable. L'auteur indique une valeur d'environ 4 en gnral.
Des valeurs plus faibles permettent d'introduire plus de variables au dtriment
de l'cart type sur Y.
Il est possible de tester plusieurs valeurs de F aprs avoir lanc le calcul.
Les donnes initiales et les rsultats sont stocks dans des listes de chanes.
Celles-ci sont sauvegardes dans des fichiers :
 donnes initiales : nomfichier.pyd,
 donnes affiches : nomfichier.pya et
 Rsultats         :           .pyr.    pour la rgession polynomiale
 et  respectivement : .mud, .mua et .mur pour la rgression multiple
 coefficients du polynome de la regression polynomiale : nomfichier.coef

Les fichiers
.pya ou .mua contiennent les chanes affichage des donnes,
.pyd ou .mud  les chanes des valeurs des donnes et  la fin le nombre de sries de
 donnes, le nombre total de variables indpendantes + dpendante et le titre du
 calcul,
.pyr ou mur : les chanes affichages des donnes et rsultats,
.coef enregistre les coefficients de la DERNIERE fonction polynomiale calcule.
 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, FileCtrl, Math;

Const
  NbMaxVar = 11;              //  soit 10 variables indpendantes + Y
  Tolerance = 1.E-4;          // 1.E-3  1.E-5 pour limiter la dgnrescence quand
 // une var. indpend. est sensiblempent une combinaison linaire des autres var.indp.
  F1init = 2;                 // parametres d'ajustement
  F2init = 2;
  CrLg = #13#10;
  ChTest = ' Affecter  F une valeur, critre de choix d''une variable (F1 >= F2)';
  Ch2AffDonP = 'NSerie      X                Y  ';
  Ch2AffDonM = 'NSerie     X1..Xn var indpendantes         Y  ';

type
  EAnnuler = class(Exception);
  TDon = Double; 
  TabMax =  Array[1..NbMaxVar] of TDon;

  TFCalculPoly = class(TForm)
    Label2: TLabel;
    EdNbS: TEdit;
    StBFDon: TStatusBar;
    Label7: TLabel;
    MemDon: TMemo;
    LaDegre: TLabel;
    EdDegre: TEdit;
    LaTitre: TLabel;
    EdTitre: TEdit;
    BtCalcul: TButton;
    PanTest: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    EdF1: TEdit;
    Label6: TLabel;
    EdF2: TEdit;
    BtTest: TButton;
    BtChargeDon: TButton;
    BtImprim: TButton;
    FlbListDon: TFileListBox;
    Label1: TLabel;
    BtCalBrut: TButton;
    EdNomFic: TEdit;
    BtModDeg: TButton;
    BtGraphe: TButton;
    LbnomF: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtCalculClick(Sender: TObject);   // calcul optimis
    procedure BtTestClick(Sender: TObject);     // initialisation de F1 et F2
    procedure FormActivate(Sender: TObject); virtual;
    procedure BtImprimClick(Sender: TObject);
    procedure FlbListDonClick(Sender: TObject); virtual; // init  partir d'un fich
    procedure BtChargeDonClick(Sender: TObject); virtual;  // select un fich.donnes
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtCalBrutClick(Sender: TObject);
        // calcul brut (toutes les puissances) sauf si limitation deg demande
    procedure BtGrapheClick(Sender: TObject); virtual;  // affiche graphe fonction
    procedure BtModDegClick(Sender: TObject);   // modifie le degr max
  private
    { Dclarations prives }
    Atab : Array[1..NbMaxVar, 1..NbMaxVar] of TDon;     // matrice des calculs
    Mtab : TabMax;      // somme des variables puis moyennes
    Stab : TabMax;      // racine carre des A[I,I]  cart type de I
    Etab : TabMax;      // Ecart type du coefficient des variables
    Ixvar, Pas : integer;  // indice var. retenue, pas calcul
    DegCalcul : integer; // limitation du degr du polynome  la demande (btModDegre)
    BLimitDeg : Boolean;  // vrai si degr max limit  DegCalcul
    Vmin, VMax : TDon;  //  acroissement de la variance
    Dl : integer;            // degr de libert
  public
{ Dclarations publiques }
    Xtab : TabMax;       //  valeurs des variables d'une srie X1..Xn & Y=Xmax
    B0  : TDon;          // B0 constante du polynome
    BtabCoef : TabMax;      // valeur estime des coef. des variables
    NAffLg : integer;    // n de ligne affiche dans MemDon
    NumS : integer;       // compteur enregistrement des sries
    NbSeries : integer;   // nbre de sries de variables
    DegreL : integer;     // degr de libert
    StlDon : TStringList;  // liste des donnes  X1,...,X1^n, Y1 ,X2.... Y2,...
    StlDonA: TStringList; //  sauvegarde affichage donnes [x,y]   (.pya)
                           //  puis avec les calculs resultats (.pyr)
    StlCoef : TStringList; // sauvegarde et lecture de B0 et des coefficients
                           // de la dernire fonction polynome
    F1, F2 : single;       // valeur du critre de variance : test d'influence
    NficSauv : string;     // nom fic sauvegarde : donnes = .pyd,
                           //  affich.donnes = .pya et Aff.rsultats = .pyr
    ExtAff : string;       // extension du f. sauveg. .pya ou .mua
    NbVar : integer;       // nbre de variables indpendantes X + var dpendante Y
    BExecPoly : Boolean;   // faux si excution  partir de RegCreatPol
    BCalBrut : Boolean;    // vrai si calcul BRUT
    BRegMultiple : boolean;     // vrai si Regression Multiple
    procedure AffValCalcules;   // AffComparaison -> valeurs
    procedure P_CalculRegression; virtual;
                          // les calculs sont identiques pour la reg. multiple
    procedure P_AffDonPoly(Ext : string); virtual;
    procedure InitDonnees; virtual;  // initialisation  partir d'une sauvegarde
    procedure P_AffTitre; virtual;  // affichage du titre principal
    procedure SauveCoefFonct;     // sauvegarde de B0 et Br de la fonction StringList
    procedure LectureCoefFonct;   // lecture des coefficients de la fonction
    procedure LectParamXY;        // lecture des donnes X et Y  partir de la StringList
  end;

var
  FCalculPoly: TFCalculPoly;

implementation

uses ListImp, RegresMultip, RegCreatPol, RegCreatMul, COURBAFF, RegAffich,
  RegGraphePoly;

{$R *.dfm}

procedure TFCalculPoly.BtCalBrutClick(Sender: TObject);
begin
  PanTest.Visible := False;   // valeurs pour Optimisation
  BCalBrut := True;
  StBFDon.SimpleText := '   ';
  P_CalculRegression;
  if BLimitDeg then       // calcul arrt  un degr infrieur au max
  begin
    BtModDeg.Visible := False;
    EdDegre.Text := IntToStr(NbMaxVar-2);
    BLimitDeg := False;
  end;
end;

procedure TFCalculPoly.BtCalculClick(Sender: TObject);  // calcul avec optimisation
begin
  PanTest.Visible := True;
  BtTest.SetFocus;
  BCalBrut := False;
  StBFDon.SimpleText := ChTest;
end;

procedure TFCalculPoly.P_AffTitre;
var Lg : string;
begin
  if BCalBrut then
  begin
    if BlimitDeg then
     StlDonA.Add('               ANALYSE BRUTE ('+'Degr max. '+ IntToStr(DegCalcul)+')')
    else  StlDonA.Add('                ANALYSE BRUTE ');
    StlDonA.Add('   ');
  end
  else
  begin
    StlDonA.Add('                OPTIMISATION ');
    StlDonA.Add('   ');
  end;

  Lg :=  ' Ecart type sur donnes Y = '+ FloatToStr(Stab[NbVar]
                                                  *Sqrt(Atab[NbVar,NbVar]/Dl));
  StlDonA.Add(Lg + CrLg);
end;

procedure TFCalculPoly.SauveCoefFonct;
var I : integer;
begin
  StlCoef.Clear;
  StlCoef.Add(FloatToStr(B0));
  for I := 1 to NbVar-1 do StlCoef.Add(FloatToStr(BtabCoef[I]));
  StlCoef.SaveToFile(NFicSauv + '.coef');// extension de la Stringlist des coeff.de YfX
end;

procedure TFCalculPoly.LectureCoefFonct;  //  partir de la sauvegarde NomFic.coef
var I : integer;
begin
  I := Pos('.', NFicSauv);
  if I <> 0 then  NFicSauv := Copy(NFicSauv, 1, I-1);
    try
      if FileExists(NficSauv + '.coef') then
      begin
        StlCoef.LoadFromFile(NFicSauv + '.coef');
        B0 :=  StrToFloat(StlCoef[0]);
        for I := 1 to NbVar -1 do BtabCoef[I] :=  StrToFloat(StlCoef[I]);
      end
      else begin
        MessageDlg('Les coefficients de YfX ne sont pas sauvegards'+CrLg
                   +'Impossible de tracer le graphe.'+CrLg
                   +' Excuter CALCUL avant.' ,mtInformation, [mbOK], 0);
        raise EAnnuler.Create('Annuler action');
      end;
    except
      on EAnnuler do Raise
    end;
end;

procedure TFCalculPoly.LectParamXY;    // lecture de la StringList contenant les donnes
                                  //  X, Y provenant de la sauvegarde .pyd
var                               // Xdtab et Ydtab tableaux des valeurs de X et Y
  J, K : integer;
begin
    SetLength(FAffGraph.Xdtab, NbSeries);
    SetLength(FAffGraph.Ydtab, NbSeries);
    K := 0;
    for J := 0 to NbSeries-1 do
      begin
        FAffGraph.Xdtab[J] := StrToFloat(StlDon[K]);
        FAffGraph.Ydtab[J] := StrToFloat(StlDon[K+NbVar-1]);
        K := K + NbVar;
      end;
end;

//========================================================================
procedure TFCalculPoly.P_CalculRegression; // les calculs sont identiques
var                                        // pour reg. multiple
  Sy : TDon;               // ecart type de Y var. dpendante
  Nmin, Nmax : integer;    // indice des var. indpendantes slectionnes
  Variance : TDon;         // variance

procedure P_SomVar_ProdVar;
var I, J, K, IxDon : integer;
begin
// Initialisation des tableaux
  for I := 1 to NbMaxVar do Mtab[I] := 0;
  for I := 1 to NbMaxVar do
    for J := 1 to NbMaxVar do Atab[I,J] := 0;
  IxDon := 0;
  for K := 1 to NbSeries do
  begin
    for I := 1 to NbVar do
    begin
      Xtab[I] := StrToFloat(StlDon[IxDon]);
      Inc(IxDon);
      Mtab[I] := Mtab[I] + Xtab[I];       // somme des variables
    end;
    for I := 1 to NbVar do
      for J := 1 to NbVar do Atab[I,J] := Atab[I,J] + Xtab[I] * Xtab[J];
  end;                                                    // sommes des produits
end;

procedure P_Moyenne_SommeResiduelle;
var I,J : integer;
begin
  for I := 1 to NbVar do
    for J := 1 to NbVar do Atab[I,J] := Atab[I,J] - Mtab[I] * Mtab[J] / NbSeries; //residu
  for I := 1 to NbVar do Mtab[I] := Mtab[I] / NbSeries;               // moyenne
end;

procedure P_Correlation_Simple;  //calcul des coef. de corrlation simple
var I,J : integer;
begin
  for I := 1 to NbVar do Stab[I] := Sqrt(Atab[I,I]);  // racine carre
  for I := 1 to NbVar-1 do
    for J := I+1 to NbVar do
    begin
      Atab[I,J] := Atab[I,J] / (Stab[I]*Stab[J]);
      Atab[J,I] := Atab[I,J];
    end;
    for I := 1 to NbVar do Atab[I,I] := 1;
end;

procedure CalNouvelMatrice;
var I, J : integer;
begin
  for I := 1 to NbVar do
    for J := 1 to NbVar do
      if (I <> Ixvar) and (J <> Ixvar)  then
             Atab[I,J] := Atab[I,J]- Atab[I,Ixvar]*Atab[Ixvar,J]/Atab[Ixvar,Ixvar];
  for I := 1 to NbVar do
    if I <> Ixvar  then Atab[I,Ixvar] := -Atab[I,Ixvar]/Atab[Ixvar,Ixvar];
  for J := 1 to NbVar do
    if J <> Ixvar then Atab[Ixvar,J] := Atab[Ixvar,J]/Atab[Ixvar,Ixvar];
  Atab[Ixvar,Ixvar] := 1/Atab[Ixvar,Ixvar];
end;

procedure AffResult;
var I : integer;
begin                      // affichage resultats
  with StlDonA do
  begin
    Add('  ');
    Add(' Pas N : '+IntToStr(Pas));
    Add(' Introduct. de la variable : '+IntToStr(Ixvar));
    Add(' Niveau F              : '+FloatToStr(Abs(Vmin)*Dl/Atab[NbVar,NbVar]));
    Add(' Ecart type sur Y      : '+FloatToStr(Stab[NbVar]*Sqrt(Atab[NbVar,NbVar]/Dl)));
    Add(' Constante B0          : '+FloatToStr(B0));
    Add('   ');
    Add(' Variable    Coefficient    Ecart type/Coefficient');
    Add('   ');
    for I := 1 to NbVar-1 do
      begin
        if (BtabCoef[I]<>0) or (Etab[I]<>0) then
          Add(' X('+IntToStr(I)+')  '   +FloatToStr(BtabCoef[I]) +'   ' +FloatToStr(Etab[I]))
      end;
  end;
end;

procedure P_AnalyseBrute;   // utilisation de toutes les variables indpendantes
var
  J : integer;
  BmajIxvar : Boolean;   // vrai si premire affectation
  DegMax : integer;      // degr max d'un calcul
begin
  StBFDon.SimpleText := '   ';
  Pas := 0;
  DegMax := 0;  // initialisation
  P_AffTitre;
repeat
    for J := 1 to NbVar do begin
      BtabCoef[J] := 0;
      Etab[J] := 0;
      end;
    Sy := Stab[NbVar] * sqrt(Atab[NbVar,NbVar] / Dl);    // cart type sur Y
 // calcul
  J := 1;
  BmajIxvar := True;
  Nmin := 0;
   repeat
     if Atab[J,J] > Tolerance then
       begin
         Variance := Atab[J,NbVar] * Atab[NbVar,J] / Atab[J,J];
          if Variance < 0 then         //  si ngatif Xi est dans la  rgression
          begin
            BtabCoef[J] := Atab[J,NbVar] * Stab[NbVar] / Stab[J]; // coeff. de rgression
            Etab[J] := Sy * Sqrt(Atab[J,J]) / Stab[J]; // cart type sur coef. regression
            Vmin := Variance;                         
            DegMax := J;                             // pour limitation degre
          end
         else begin
               BtabCoef[J] := 0;
               if BmajIxvar then Nmin := J;
               BmajIxvar := False;
             end;
       end;
       Inc(J);
   until J = NbVar ;

  B0 := Mtab[NbVar];                      // calcul de  B0
  for J := 1 to NbVar - 1 do  B0 := B0 - BtabCoef[J] * Mtab[J];
  if Pas > 0 then AffResult;

  if BLimitDeg then if DegMax >= DegCalcul then Exit; //calcul avec limitation degr
  if Nmin = 0 then Exit;
  Ixvar := Nmin;
  CalNouvelMatrice;
  Dec(Dl);  // diminution du degr libert aprs le pas = 0
  if Dl = 0 then Exit;

  Inc(Pas);                 // pas suivant
until false;

end;
//--------------------------------------------------------------------------
procedure  P_Analyse_par_pas;
var I,J : integer;
  P1 : integer;
  BFin : boolean;         // true si P1 = Nvar-1

procedure P_VarplusSignificative;
begin
  I := 1;
  repeat
// 6 - controle grandeur A[I,I]
    if Atab[I,I] > Tolerance then
    begin
// 7 - calcul du delta de l'accroissement de variance
      Variance := Atab[I,NbVar] * Atab[NbVar,I] / Atab[I,I];
// 8 - siV<0 Xi dj dans la rgression, si V>0 il n'y est pas
      if Variance < 0 then
      begin
// 11 - calcul des coef. de rgression et cart type
        BtabCoef[I] := Atab[I,NbVar] * Stab[NbVar] / Stab[I];
        Etab[I] := Sy * Sqrt(Atab[I,I]) / Stab[I];
// 12 - test pour le min. de V
        if (Abs(Variance)) < (Abs(Vmin)) then
        begin
// 13 - Xi correspond au minimum de V
          Vmin := Variance;
          Nmin := I;
        end;
      end
      else   // V >= 0
      begin
// 9 - test pour le max. de V
        if (Variance > 0) and (Variance > VMax) then  begin
// 10 - Xi correspondant au max de V
          VMax := Variance;
          Nmax := I;
          BtabCoef[I] := 0;
        end;
      end;
    end;
// 14 -
    I := I + 1;

  until I = NbVar;
end;

//------------------------------------------------------------------------------
begin                     //    P_Analyse_par_pas,  calcul optimis
  Pas := 0;  P1 := 0;
  BFin := false;

repeat
  for J := 1 to NbVar do
    begin
      BtabCoef[J] := 0;
      Etab[J] := 0;
    end;
// 5 - init. proc. dtermination var plus significarive
  Sy := Stab[NbVar] * sqrt(Atab[NbVar,NbVar] / Dl);
  Vmin := 9.E95;
  VMax := 0; Nmin :=0; Nmax := 0;

  P_VarplusSignificative;

// 16 - Calcul de la constante B0
  B0 := Mtab[NbVar];
  for J := 1 to NbVar - 1 do  B0 := B0 - BtabCoef[J] * Mtab[J];
  if Pas > 0 then AffResult;
  if BFin and (P1 < NbVar-1) then Exit;
// - 17
  if Abs(Vmin) * Dl / Atab[NbVar,NbVar] < F2 then
  begin
// 18
    Ixvar := Nmin;
    Dl := Dl+1;
    P1 :=P1-1;
  end
  else
  begin
// 19
    if (VMax * Dl / (Atab[NbVar, NbVar] - VMax) <= F1) and (Pas>0) then Exit;
// 20
    Ixvar := Nmax;
    Dl := Dl-1;
    P1 := P1+1;
    if P1 = NbVar-1 then BFin := true;
  end;
   if Dl = 0 then Exit;
// 21 algorithme de retrait ou d'introduction - calcul nouvelle matrice
  CalNouvelMatrice;

  if (Pas > 0) and (P1=0) then
  begin
    MessageDlg(' La valeur de F1 est trop leve.' + CRLG +
               'Relancer OPTIMISATION avec des ' + CRLG +
               'valeurs de F1 et F2 plus faibles',mtInformation, [mbOK], 0);
    Exit;
  end;
  Pas := Pas+1;
until false;

end;
//--------------------------P_CalculRegression-----------------------------------
begin
  Dl := DegreL;
// 2 - Calcul sommes des variables et sommes des produits des variables
  P_SomVar_ProdVar;
// 3 - Calcul des moyennes des sommes et des sommes rsiduelles des produits
  P_Moyenne_SommeResiduelle;
// 4 - calcul des coef. de corrlation simple
  P_Correlation_Simple;
  StlDonA.Add('       ');
  StlDonA.Add('========================================================');

  if BCalBrut then P_AnalyseBrute
              else
              begin                        // Optimisation
                P_AffTitre;
                StlDonA.Add(' NIVEAUX F - Introduction : '+EdF1.Text+ CrLg+
                            '             Rejet        : '+EdF2.Text);
                P_Analyse_par_pas;
//                SauveCoefFonct;
              end;
  SauveCoefFonct;
  AffValCalcules;          // comparaison valeurs donnes, calcules et carts
  BtImprim.Visible := true;
//  if BRegMultiple then BtGraphe.Visible := False
      BtGraphe.Visible := True;

//  if not BRegMultiple then SauveCoefFonct;         ????????????????
end;
//==========================================================================

procedure TFCalculPoly.BtTestClick(Sender: TObject);
begin
  F1 := StrToFloat(EdF1.Text);     // valeurs des critres de test
  F2 := StrToFloat(EdF2.Text);
  if (F1<F2) or (F1=0) then               // F1 doit tre SUP ou =  F2
  begin
    StBFDon.SimpleText := ' F1 doit tre > ou =  F2';
    BtTest.SetFocus;
    Exit;
  end;
  StBFDon.SimpleText := '  ';
  P_CalculRegression;
  PanTest.Visible := False;
end;

procedure TFCalculPoly.InitDonnees;   //  partir du fichier sauvegarde des chanes
var I : integer;
begin
  StlDon.LoadFromFile(NFicSAuv);
  I := StlDon.Count;
  EdTitre.Text := StlDon[I-1];       // titre des donnes de la regression
  NbVar :=  StrToInt(StlDon[I-2]);   // nd total de variables
  NbSeries := StrToInt(StlDon[I-3]);  // nb de series de donnes
  EdNbS.Text := StlDon[I-3];          // NbSeries
  DegreL := NbSeries - 1;             // degr de libert pour calcul de Sy
  EdDegre.Text := IntToStr(NbVar-2);  // degr max initial
  MemDon.Clear;
  P_AffDonPoly(ExtAff);

  if BtCalcul.Visible = True then BtCalcul.SetFocus;   // modif pour Graphe
  FlbListDon.Visible := false;
  EdNomFic.Text := ExtractFileName(NFicSauv);
end;

procedure TFCalculPoly.FlbListDonClick(Sender: TObject);
begin
  NficSauv := FlbListDon.FileName;
  InitDonnees;
  StBFDon.SimpleText :=
   ' CHOISIR une mthode de calcul ou MODIFIER le DEGRE et excuter ANAL.BRUTE';
  BtModDeg.Visible := True;
  EdDegre.SetFocus;
  BLimitDeg := False;
end;

procedure TFCalculPoly.FormActivate(Sender: TObject);
begin
  EdF1.Text := FloatToStr(F1init);
  EdF2.Text := FloatToStr(F2init);
  ExtAff := '.pya';

  if BExecPoly then
    begin                            // excution  partir d'un fichier donnes
      BtChargeDon.Visible := True;
      BtChargeDon.SetFocus;
      StBFDon.SimpleText := '  Slectionner un fichier donnes';
    end
    else
      begin                 // excution  partir de cration nouvelles sries
        BtChargeDon.Visible := False;
        StBFDon.SimpleText := '  Traiter les donnes cres';
        FregCreatPol.Visible := False;
        FRegCreatPol.Close;
      end;
end;

procedure TFCalculPoly.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
    FlbListDon.Visible := False;
    StlDon.Clear;
    StlDonA.Clear;
    StlCoef.Clear;
    MemDon.Clear;
    EdTitre.Text := '';
    EdNomFic.Text := '';
    EdNbS.Text := '';
    EdDegre.Text := '';
    BtChargeDon.Visible := True;
    BtGraphe.Visible := False;
  except
    on  E: EStackOverflow do
      begin
        MessageDlg(' FDon.../FormClose. Erreur N : ' +
           IntToStr(E.HelpContext)+ CrLg + E.Message, mtInformation,[mbOK], 0);
        raise;
      end;
  end;
end;

procedure TFCalculPoly.FormCreate(Sender: TObject);
begin
  F1 := F1init;
  F2 := F2init;
  if StlDon = Nil then StlDon := TStringList.Create;
  if StlDonA = nil then StlDonA := TStringList.Create;
  if StlCoef = nil then StlCoef := TStringList.Create;
  NFicSauv := 'WEssai';
end;

procedure TFCalculPoly.FormDestroy(Sender: TObject);
begin
  StlDon.Free;
  StlDonA.Free;
  StlCoef.Free;
end;

procedure TFCalculPoly.P_AffDonPoly(Ext : string);
begin
  StlDonA.Clear;
  NficSauv := Copy(NficSauv, 1, Length(NficSauv)-4);
  if FileExists(NficSauv+'.pyr') then StlDonA.LoadFromFile(NFicSauv+ '.pyr')
     else StlDonA.LoadFromFile(NFicSauv+ '.pya');
  MemDon.Lines.Assign(StlDonA);                  // affichage des donnes
end;

//=============================================================================
procedure TFCalculPoly.AffValCalcules;
var Ext : string;

procedure Aff_Elem_Diag;
var I : integer;
begin
  with StlDonA do
  begin
    Add('   ');
    Add('   Elments diagonaux');
    Add(' Var.N       Valeur');
    for I := 1 to NbVar-1 do Add('  '+IntToStr(I)+'     '+ FloatToStr(Atab[I,I]));
  end;
end;

procedure Aff_Val_Y;
var I, J, K, IxDon : integer;
    Yc, Yd : TDon;        // valeur calcule  et donne
begin
  StlDonA.Add('   ');
  StlDonA.Add('       Valeurs de Y DONNEES et CALCULEES'+CrLg);
  StlDonA.Add(' N   Y Donnes        Calcules         Ecarts');

  IxDon := 0;
  for J := 1 to NbSeries do
    begin
//      Yc := B0;                             // valeur de Y calcule
      for K := 1 to NbVar -1 do             // lecture des donnes X
      begin
        Xtab[K] :=  StrToFloat(StlDon[IxDon]);
        Inc(IxDon);
      end;

      Yc := B0;                             // valeur de Y calcule
      for I := 1 to Pas+1 do  Yc := Yc + BtabCoef[I]*Xtab[I];
      Yd := StrToFloat(StlDon[IxDon]);      // valeur de Y donne
      Inc(IxDon);
      StlDonA.Add(' '+Format('%2d',[J])+
           StringOfChar(' ',12-Length(FloatToStr(Yd)))+ FloatToStr(Yd)+
           StringOfChar(' ',20-Length(FloatToStr(Yc)))+ FloatToStr(Yc)
           +'  '+ FloatToStr(Yd-Yc));
    end;
  StlDonA.Add('   ');
end;
//-------------------------------------  AffValCalcules -----------------------
begin
  Aff_Elem_diag;
  Aff_Val_Y;
  if BCalbrut then StBFDon.SimpleText := '  '
  else StBFDon.SimpleText := '  Si necessaire Modifier valeurs de F'+
                             ' et/ou excuter puis SORTIR';
  MemDon.Lines.Assign(StlDonA);
  if ExtAff = '.pya' then Ext := '.pyr'         // fichier rsultats
                     else Ext := '.mur';
  StlDonA.SaveToFile(NFicSauv+Ext);            //sauvegarde des rsultats
end;
//=============================================================================

procedure TFCalculPoly.BtImprimClick(Sender: TObject);
var Ch : string;
begin
  if ExtAff = '.pya' then Ch := '    Regression Polynomiale'
                     else Ch := '    Regression Multiple';
  try
    FImprime := TFImprime.Create(Self);
    FImprime.ImpSTList(EdTitre.Text,Ch,EdTitre.Text, StlDonA);
  finally
    BtImprim.Visible := false;
    MemDon.Clear;
    FImprime.Free;
  end;
end;
//  FImprime.ImpSTList({EdTitre.Text}'  ',Ch, NficAff, StlAffich);
procedure TFCalculPoly.BtModDegClick(Sender: TObject);
begin
  DegCalcul := StrToInt(EdDegre.Text);
  if DegCalcul < NbMaxVar - 1 then   // Degcalcul est < au degr initial
  begin
    BLimitDeg := True;
    BtCalBrut.SetFocus;
  end
  else
  begin                            // modification du degr
    EdDegre.SetFocus;
    ShowMessage('Degr doit tre <= '+ IntToStr(NbMaxVar-2));
    Exit;
  end;
end;

procedure TFCalculPoly.BtChargeDonClick(Sender: TObject);
begin
  FlbListDon.Visible := true;
  FlbListDon.Update;
end;

procedure TFCalculPoly.BtGrapheClick(Sender: TObject);
begin
  FAffGraph.BFDonPoly := True;
  LectParamXY;
  FAffGraph.AfficheGraphe;
end;

end.

